package bitcreek.client;

import java.net.InetSocketAddress;
import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * @author  Giulio Tranchida (gtranchi) no. matricola 241732<br>
 * 	     	Progetto LPR anno 2008/2009. */
public interface ClientInterface extends Remote{
	
	/**
	 * Callback. Notifica quali Peer hanno scaricato il descrittore di file
	 * che questo client ha pubblicato sul server.
	 *  @param filename Nome del descrittore di file a cui e' legata la
	 *         callback
	 * @param idPeer L'identita' del Peer che ha scaricato il descrittore che
	 *        questo Client ha pubblicato.
	 *  @throws RemoteException */
	public void notifyMe(String filename, InetSocketAddress idPeer)
		throws RemoteException;

	/** Il server RMI chimera' questa funzione per identificare il
	 * client stesso. Ogni peer viene identificato, univocamente,
	 * dalla coppia "Indirizzo Ip:Porta".
	 * @return Ritorna l'indirizzo Ip e la porta del client al server. 
	 * @throws RemoteException */
	public InetSocketAddress getId() throws RemoteException;
}
